#include <iostream>
#include <cstdio>
using namespace std;
int n,i,j,ii,jj,tj,s,sss,c; long int k; 
bool bo;
int main(){
    scanf("%i %li", &n, &k); c=0;
    int p[n+2][n+2]; bool x[n+2][n+2]; int ss[k+1]; ss[0]=2; 
    for(i=0;i<n;i++){
        for(j=0;j<n;j++){
            scanf("%li", &p[i][j]);
            x[i][j]=false;
        }
        p[i][n]=0; p[n][i]=0;
    }
    for(i=1;i<=k;i++) ss[i]=0;
    for(i=0;i<n;i++){
        for(j=0;j<n;j++){
            if(!x[i][j]){
                s=p[i][j];
                if(ss[s]==1){
                    c-=1; ss[s]=2;
                }
                if(ss[s]==0){
                    jj=j; ii=i;
                    for(;p[i][jj]==s;jj++){ x[i][jj]=true; }
                    tj=jj; bo=true;
                    for(;bo;ii++){
                        if(p[ii][j]==s){
                            x[ii][j]=true;
                            for(jj=j+1;jj<tj;jj++){
                                if(p[ii][jj]==s){ x[ii][jj]=true; }
                                else{
                                    ss[s]=2; bo=false; break;
                                }
                            }
                        } else{
                            ss[s]=1; c++; break;
                        }
                    }
                }
            }
        }
    }
    printf("%d",c);
    return 0;
}